<template>
    <v-row>
        <v-col md="12" lg="12">
            <v-card>
                <v-container fluid fill-height class="image-preview grey lighten-2">
                    <v-row v-if="!!images.length" justify="center">
                        <draggable
                            class="d-flex col justify-center flex-wrap"
                            v-model="images"
                            group="uploaded"
                            @start="drag = true"
                            @end="drag = false"
                        >
                            <v-col
                                v-for="image in images"
                                :key="image.id"
                                class="d-flex child-flex"
                                cols="2"
                            >
                                <v-card flat tile class="d-flex grey lighten-2">
                                    <v-img :src="image.url" aspect-ratio="1">
                                        <v-btn class="ma-2 primary"
                                               small
                                               icon
                                               left
                                               top
                                               @click="deleteImage(image.id)"
                                        >
                                            <v-icon color="white">mdi-close</v-icon>
                                        </v-btn>
                                    </v-img>
                                </v-card>
                            </v-col>
                        </draggable>
                    </v-row>

                    <v-row v-else align="center" justify="center">
                        <v-col cols="4">
                            <div class="text-center">
                                <span>
                                    <v-icon x-large color="grey darken-1">mdi-camera</v-icon>
                                </span>
                                <h3 class="grey--text text--darken-1">
                                    {{ $t('no_image_uploaded') }}
                                </h3>
                            </div>
                        </v-col>
                    </v-row>
                </v-container>
            </v-card>
        </v-col>
    </v-row>
</template>

<script>
    import draggable from 'vuedraggable'

    export default {
        name: "ProductImageEditor",
        components: {
            draggable
        },
        props: {
            value: {
                type: Array,
                default: () => []
            }
        },
        computed: {
            images: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('move', val);

                    val.forEach((image, index) => {
                        image.sort = index;
                    });

                    return this.$emit('input', val);
                }
            }
        },
        methods: {
            deleteImage(id) {
                const index = this.images.findIndex(image => image.id === id);
                this.images.splice(index, 1);
                this.$emit('deleted', id);
            },
        }
    }
</script>

<style scoped>
    .image-preview {
        min-height: 220px;
    }
</style>
